# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['FilesystemArgs', 'Filesystem']

@pulumi.input_type
class FilesystemArgs:
    def __init__(__self__, *,
                 region: pulumi.Input[str],
                 size: pulumi.Input[int],
                 type: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 retain_on_delete: Optional[pulumi.Input[bool]] = None,
                 timeouts: Optional[pulumi.Input['FilesystemTimeoutsArgs']] = None):
        """
        The set of arguments for constructing a Filesystem resource.
        :param pulumi.Input[str] region: The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
               destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[int] size: The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
               recreate the resource. - The value must be at least 1.
        :param pulumi.Input[str] type: The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
               resource. - The value must be one of: ["vast"].
        :param pulumi.Input[str] description: The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        :param pulumi.Input[str] name: The human-readable name for the filesystem.
        :param pulumi.Input[bool] retain_on_delete: Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        """
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "size", size)
        pulumi.set(__self__, "type", type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if retain_on_delete is not None:
            pulumi.set(__self__, "retain_on_delete", retain_on_delete)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)

    @property
    @pulumi.getter
    def region(self) -> pulumi.Input[str]:
        """
        The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
        destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: pulumi.Input[str]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def size(self) -> pulumi.Input[int]:
        """
        The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
        recreate the resource. - The value must be at least 1.
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: pulumi.Input[int]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
        resource. - The value must be one of: ["vast"].
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable name for the filesystem.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="retainOnDelete")
    def retain_on_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        """
        return pulumi.get(self, "retain_on_delete")

    @retain_on_delete.setter
    def retain_on_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "retain_on_delete", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['FilesystemTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['FilesystemTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)


@pulumi.input_type
class _FilesystemState:
    def __init__(__self__, *,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 mount_base_path: Optional[pulumi.Input[str]] = None,
                 mount_endpoint_ranges: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retain_on_delete: Optional[pulumi.Input[bool]] = None,
                 size: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 timeouts: Optional[pulumi.Input['FilesystemTimeoutsArgs']] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Filesystem resources.
        :param pulumi.Input[str] created_at: The timestamp when this filesystem was created in RFC 3339.
        :param pulumi.Input[str] description: The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        :param pulumi.Input[str] mount_base_path: The base path on the server under which the mount point can be accessed.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] mount_endpoint_ranges: The start and end IP of the mount endpoint range. Expressed as a array with two entries.
        :param pulumi.Input[str] name: The human-readable name for the filesystem.
        :param pulumi.Input[str] region: The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
               destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[bool] retain_on_delete: Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        :param pulumi.Input[int] size: The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
               recreate the resource. - The value must be at least 1.
        :param pulumi.Input[str] status: The filesystem status.
        :param pulumi.Input[str] type: The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
               resource. - The value must be one of: ["vast"].
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if mount_base_path is not None:
            pulumi.set(__self__, "mount_base_path", mount_base_path)
        if mount_endpoint_ranges is not None:
            pulumi.set(__self__, "mount_endpoint_ranges", mount_endpoint_ranges)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if retain_on_delete is not None:
            pulumi.set(__self__, "retain_on_delete", retain_on_delete)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The timestamp when this filesystem was created in RFC 3339.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="mountBasePath")
    def mount_base_path(self) -> Optional[pulumi.Input[str]]:
        """
        The base path on the server under which the mount point can be accessed.
        """
        return pulumi.get(self, "mount_base_path")

    @mount_base_path.setter
    def mount_base_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mount_base_path", value)

    @property
    @pulumi.getter(name="mountEndpointRanges")
    def mount_endpoint_ranges(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The start and end IP of the mount endpoint range. Expressed as a array with two entries.
        """
        return pulumi.get(self, "mount_endpoint_ranges")

    @mount_endpoint_ranges.setter
    def mount_endpoint_ranges(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "mount_endpoint_ranges", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The human-readable name for the filesystem.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
        destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="retainOnDelete")
    def retain_on_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        """
        return pulumi.get(self, "retain_on_delete")

    @retain_on_delete.setter
    def retain_on_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "retain_on_delete", value)

    @property
    @pulumi.getter
    def size(self) -> Optional[pulumi.Input[int]]:
        """
        The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
        recreate the resource. - The value must be at least 1.
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The filesystem status.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['FilesystemTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['FilesystemTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
        resource. - The value must be one of: ["vast"].
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class Filesystem(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retain_on_delete: Optional[pulumi.Input[bool]] = None,
                 size: Optional[pulumi.Input[int]] = None,
                 timeouts: Optional[pulumi.Input[pulumi.InputType['FilesystemTimeoutsArgs']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Filesystem resource

        ## Example Usage

        ```python
        import pulumi
        import pulumi_genesiscloud as genesiscloud

        example = genesiscloud.Filesystem("example",
            description="Example filesystem",
            region="NORD-NO-KRS-1",
            size=50,
            type="vast")
        ```

        ## Import

        ```sh
         $ pulumi import genesiscloud:index/filesystem:Filesystem example 18efeec8-94f0-4776-8ff2-5e9b49c74608
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        :param pulumi.Input[str] name: The human-readable name for the filesystem.
        :param pulumi.Input[str] region: The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
               destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[bool] retain_on_delete: Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        :param pulumi.Input[int] size: The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
               recreate the resource. - The value must be at least 1.
        :param pulumi.Input[str] type: The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
               resource. - The value must be one of: ["vast"].
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FilesystemArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Filesystem resource

        ## Example Usage

        ```python
        import pulumi
        import pulumi_genesiscloud as genesiscloud

        example = genesiscloud.Filesystem("example",
            description="Example filesystem",
            region="NORD-NO-KRS-1",
            size=50,
            type="vast")
        ```

        ## Import

        ```sh
         $ pulumi import genesiscloud:index/filesystem:Filesystem example 18efeec8-94f0-4776-8ff2-5e9b49c74608
        ```

        :param str resource_name: The name of the resource.
        :param FilesystemArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FilesystemArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retain_on_delete: Optional[pulumi.Input[bool]] = None,
                 size: Optional[pulumi.Input[int]] = None,
                 timeouts: Optional[pulumi.Input[pulumi.InputType['FilesystemTimeoutsArgs']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FilesystemArgs.__new__(FilesystemArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["name"] = name
            if region is None and not opts.urn:
                raise TypeError("Missing required property 'region'")
            __props__.__dict__["region"] = region
            __props__.__dict__["retain_on_delete"] = retain_on_delete
            if size is None and not opts.urn:
                raise TypeError("Missing required property 'size'")
            __props__.__dict__["size"] = size
            __props__.__dict__["timeouts"] = timeouts
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["created_at"] = None
            __props__.__dict__["mount_base_path"] = None
            __props__.__dict__["mount_endpoint_ranges"] = None
            __props__.__dict__["status"] = None
        super(Filesystem, __self__).__init__(
            'genesiscloud:index/filesystem:Filesystem',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            mount_base_path: Optional[pulumi.Input[str]] = None,
            mount_endpoint_ranges: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            retain_on_delete: Optional[pulumi.Input[bool]] = None,
            size: Optional[pulumi.Input[int]] = None,
            status: Optional[pulumi.Input[str]] = None,
            timeouts: Optional[pulumi.Input[pulumi.InputType['FilesystemTimeoutsArgs']]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'Filesystem':
        """
        Get an existing Filesystem resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] created_at: The timestamp when this filesystem was created in RFC 3339.
        :param pulumi.Input[str] description: The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        :param pulumi.Input[str] mount_base_path: The base path on the server under which the mount point can be accessed.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] mount_endpoint_ranges: The start and end IP of the mount endpoint range. Expressed as a array with two entries.
        :param pulumi.Input[str] name: The human-readable name for the filesystem.
        :param pulumi.Input[str] region: The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
               destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        :param pulumi.Input[bool] retain_on_delete: Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        :param pulumi.Input[int] size: The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
               recreate the resource. - The value must be at least 1.
        :param pulumi.Input[str] status: The filesystem status.
        :param pulumi.Input[str] type: The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
               resource. - The value must be one of: ["vast"].
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FilesystemState.__new__(_FilesystemState)

        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["mount_base_path"] = mount_base_path
        __props__.__dict__["mount_endpoint_ranges"] = mount_endpoint_ranges
        __props__.__dict__["name"] = name
        __props__.__dict__["region"] = region
        __props__.__dict__["retain_on_delete"] = retain_on_delete
        __props__.__dict__["size"] = size
        __props__.__dict__["status"] = status
        __props__.__dict__["timeouts"] = timeouts
        __props__.__dict__["type"] = type
        return Filesystem(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The timestamp when this filesystem was created in RFC 3339.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        The human-readable description for the filesystem. - Sets the default value "" if the attribute is not set.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="mountBasePath")
    def mount_base_path(self) -> pulumi.Output[str]:
        """
        The base path on the server under which the mount point can be accessed.
        """
        return pulumi.get(self, "mount_base_path")

    @property
    @pulumi.getter(name="mountEndpointRanges")
    def mount_endpoint_ranges(self) -> pulumi.Output[Sequence[str]]:
        """
        The start and end IP of the mount endpoint range. Expressed as a array with two entries.
        """
        return pulumi.get(self, "mount_endpoint_ranges")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The human-readable name for the filesystem.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        The identifier for the region this filesystem exists in. - If the value of this attribute changes, Terraform will
        destroy and recreate the resource. - The value must be one of: ["ARC-IS-HAF-1" "EUC-DE-MUC-1" "NORD-NO-KRS-1"].
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="retainOnDelete")
    def retain_on_delete(self) -> pulumi.Output[bool]:
        """
        Flag to retain the filesystem when the resource is deleted - Sets the default value "false" if the attribute is not set.
        """
        return pulumi.get(self, "retain_on_delete")

    @property
    @pulumi.getter
    def size(self) -> pulumi.Output[int]:
        """
        The storage size of this filesystem given in GiB. - If the value of this attribute changes, Terraform will destroy and
        recreate the resource. - The value must be at least 1.
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The filesystem status.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def timeouts(self) -> pulumi.Output[Optional['outputs.FilesystemTimeouts']]:
        return pulumi.get(self, "timeouts")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The storage type of the filesystem. - If the value of this attribute changes, Terraform will destroy and recreate the
        resource. - The value must be one of: ["vast"].
        """
        return pulumi.get(self, "type")

